﻿using System;
using System.Collections.Generic;
using Semiodesk.Trinity;
using Newtonsoft.Json;
using System.Linq;

namespace DataModel
{
    [RdfClass(FOAF.Agent)]
    public class Agent : Resource
    {
        public Agent(Uri uri) : base(uri)
        {}

        [RdfProperty(FOAF.name)]
        public string Name { get; set; }

        [RdfProperty(FOAF.mbox)]
        public List<Resource> EMailAccounts { get; set; }
    }

    [RdfClass(FOAF.Person)]
    public class Person : Agent
    {
        public Person() :  base(new Uri("http://dummy"))
        {
           
        }

        public Person(Uri uri) : base(uri)
        {}

        [RdfProperty(FOAF.knows), JsonIgnore]
        public List<Person> Knows { get; set; }

        public IEnumerable<Uri> knows
        {
            get { return from x in Knows select x.Uri; }
        }
    }

    [RdfClass(FOAF.Group)]
    public class Group : Agent
    {
        public Group(Uri uri) : base(uri)
        {}

        [RdfProperty(FOAF.member)]
        public List<Agent> Member { get; set; }
    }
}
