﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.AspNet.SignalR;
using DataModel;
using Semiodesk.Examples.WebApp.Models;
using Semiodesk.Examples.WebApp.Utils;

namespace Semiodesk.Examples.WebApp.Hubs
{
    public class People : Hub
    {
        public People()
        {
            
        }

        private PersonRepository GetRepository()
        {
            Uri modelUri = new Uri("http://semiodesk.com/example/people");
            return new PersonRepository(modelUri);

        }

        public IEnumerable<Person> ListPeople(int numberOfPeople)
        {
            GenerateRandomPeople(numberOfPeople);
            var repo = GetRepository();
            var res = repo.List().ToList();
            return res;
        }

        public Person GetPerson(string uri)
        {
            var repo = GetRepository();
            return repo.FindByUri(new Uri(uri));
        }

        public void GenerateRandomPeople(int numberOfPeople)
        {
            var repo = GetRepository();
            repo.Clear();

            PersonGenerator gen = new PersonGenerator();
            var x = gen.CreatePeople(numberOfPeople, 1, 3).ToList();
            foreach (var p in x)
                repo.Add(p);
        }
    }
}