﻿using DataModel;
using SCG.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Semiodesk.Examples.WebApp.Utils
{
    public class PersonGenerator
    {
        private static MarkovNameGenerator _generator = null;

        #region Constructor
        public PersonGenerator()
        {
            if (_generator == null)
            {
                 _generator = new MarkovNameGenerator(new string[]{
                 
    "Marin",
    "Renna",
    "Kirstin",
    "Elly",
    "Margarite",
    "Nell",
    "Erwin",
    "Renaldo",
    "Donnell",
    "Kristofer",
    "Buford",
    "Beata",
    "Pauline",
    "Thomas"}, 1, 5);
            }
        }

        public List<Person> CreatePeople(int count, int minConnections, int maxConnections)
        {
            Random r = new Random();
            List<Person> people = new List<Person>();
            for (int i = 0; i < count; i++)
            {
                string firstName = _generator.NextName;
                string lastName = _generator.NextName;

                Person p = new Person(new Uri(string.Format("http://semiodesk.com/exaple/person/{0}_{1}", firstName, lastName)));
                p.Name = string.Format("{0} {1}", firstName, lastName);
                
                people.Add(p);
            }

            foreach (var p in people)
            {
                int con = r.Next(minConnections, maxConnections + 1);
                for (int j = 0; j < con; j++)
                {
                    int knows = 0;
                    do
                    {
                        knows = r.Next(0, people.Count);
                    } while (people[knows] == p);
                    var other = people[knows];
                    
                    if( !p.Knows.Contains(other))
                        p.Knows.Add(other);

                    if( !other.Knows.Contains(p))
                        other.Knows.Add(p);
                }
            }

            return people;
        }
        #endregion
    }
}